Botan 2.1.0 Crypto and TLS for C++11

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Member Functions | List of all members
Botan::Base64_Decoder Class Referencefinal

`#include <b64_filt.h>`

Inheritance diagram for Botan::Base64_Decoder:

## Public Member Functions
virtual bool | attachable ()
| Base64_Decoder (Decoder_Checking checking=NONE)
void | end_msg () override
std::string | name () const override
virtual void | start_msg ()
void | write (const uint8_t input[], size_t length) override

## Protected Member Functions
virtual void | send (const uint8_t in[], size_t length)
void | send (uint8_t in)
void | send (const secure_vector< uint8_t > &in)
void | send (const std::vector< uint8_t > &in)
void | send (const secure_vector< uint8_t > &in, size_t length)
void | send (const std::vector< uint8_t > &in, size_t length)

## Detailed Description

This object represents a Base64 decoder.

Definition at line 57 of file b64_filt.h.

## Constructor & Destructor Documentation

Botan::Base64_Decoder::Base64_Decoder | ( | Decoder_Checking | checking = `NONE` | ) |
| explicit

Create a base64 decoder.

Parameters

  checking | the type of checking that shall be performed by the decoder

Definition at line 116 of file b64_filt.cpp.

116 :
117 m_checking(c), m_in(64), m_out(48), m_position(0)
118 {
119 }

## Member Function Documentation

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 52 of file filter.h.

52 { return true; }

void Botan::Base64_Decoder::end_msg | ( |  | ) |
| override virtual

Finish up the current message

Reimplemented from Botan::Filter.

Definition at line 163 of file b64_filt.cpp.

References Botan::base64_decode(), Botan::FULL_CHECK, and Botan::Filter::send().

164 {
165 size_t consumed = 0;
166 size_t written = base64_decode(m_out.data(),
167 reinterpret_cast<const char*>(m_in.data()),
168 m_position,
169 consumed,
170 true,
171 m_checking != FULL_CHECK);
172
173 send(m_out, written);
174
175 const bool not_full_bytes = consumed != m_position;
176
177 m_position = 0;
178
179 if(not_full_bytes)
180 throw Invalid_Argument("Base64_Decoder: Input not full bytes");
181 }
Botan::base64_decode
size_t base64_decode(uint8_t output[], const char input[], size_t input_length, size_t &input_consumed, bool final_inputs, bool ignore_ws)
Definition: base64.cpp:100
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
Botan::FULL_CHECK
Definition: filter.h:179

std::string Botan::Base64_Decoder::name | ( |  | ) | const
| inline override virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 60 of file b64_filt.h.

60 { return "Base64_Decoder"; }

void Botan::Filter::send | ( | const uint8_t | in[],
|  | size_t | length
| ) |  |
| protected virtual inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 27 of file filter.cpp.

References Botan::Filter::write().

Referenced by Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::Hex_Decoder::end_msg(), end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::StreamCipher_Filter::write(), Botan::Hex_Decoder::write(), and write().

28 {
29 if(!length)
30 return;
31
32 bool nothing_attached = true;
33 for(size_t j = 0; j != total_ports(); ++j)
34 if(m_next[j])
35 {
36 if(m_write_queue.size())
37 m_next[j]->write(m_write_queue.data(), m_write_queue.size());
38 m_next[j]->write(input, length);
39 nothing_attached = false;
40 }
41
42 if(nothing_attached)
43 m_write_queue += std::make_pair(input, length);
44 else
45 m_write_queue.clear();
46 }
Botan::Filter::write
virtual void write(const uint8_t input[], size_t length)=0

void Botan::Filter::send | ( | uint8_t | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 65 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

65 { send(&in, 1); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 70 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

70 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 75 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

75 { send(in.data(), in.size()); }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const secure_vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 81 of file filter.h.

82 {
83 send(in.data(), length);
84 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

void Botan::Filter::send | ( | const std::vector< uint8_t > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 90 of file filter.h.

91 {
92 send(in.data(), length);
93 }
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Definition at line 40 of file filter.h.

40 {}

void Botan::Base64_Decoder::write | ( | const uint8_t | input[],
|  | size_t | length
| ) |  |
| override virtual

Input a part of a message to the decoder.

Parameters

  input | the message to input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 124 of file b64_filt.cpp.

References Botan::base64_decode(), Botan::copy_mem(), Botan::FULL_CHECK, and Botan::Filter::send().

125 {
126 while(length)
127 {
128 size_t to_copy = std::min<size_t>(length, m_in.size() - m_position);
129 if(to_copy == 0)
130 {
131 m_in.resize(m_in.size()*2);
132 m_out.resize(m_out.size()*2);
133 }
134 copy_mem(&m_in[m_position], input, to_copy);
135 m_position += to_copy;
136
137 size_t consumed = 0;
138 size_t written = base64_decode(m_out.data(),
139 reinterpret_cast<const char*>(m_in.data()),
140 m_position,
141 consumed,
142 false,
143 m_checking != FULL_CHECK);
144
145 send(m_out, written);
146
147 if(consumed != m_position)
148 {
149 copy_mem(m_in.data(), m_in.data() + consumed, m_position - consumed);
150 m_position = m_position - consumed;
151 }
152 else
153 m_position = 0;
154
155 length -= to_copy;
156 input += to_copy;
157 }
158 }
Botan::base64_decode
size_t base64_decode(uint8_t output[], const char input[], size_t input_length, size_t &input_consumed, bool final_inputs, bool ignore_ws)
Definition: base64.cpp:100
Botan::Filter::send
virtual void send(const uint8_t in[], size_t length)
Definition: filter.cpp:27
Botan::FULL_CHECK
Definition: filter.h:179
Botan::copy_mem
void copy_mem(T *out, const T *in, size_t n)
Definition: mem_ops.h:68

The documentation for this class was generated from the following files:

- src/lib/filters/codec_filt/b64_filt.h
- src/lib/filters/codec_filt/b64_filt.cpp